/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 10/27/2001 */

#include "bitmap.h"
#include "h3.h"
#include "../datatypes/typedefs.h"

#ifndef ABMP_H
#define ABMP_H

#define MAX_COMPONENTS  32

class abmp{
 public:
  abmp(int b, int c, int bigb, int spanbig, int memory, double rhominbig,
       double rhomaxbig, int flowIDsize);
  ~abmp();
  void new_packet(byte* flowID);
  int estimate();
  void reset();
 private:
  int b;         // The size of a normal component
  int c;         // The number of components
  int lastb;     // The size of the last component
  int bigb;      // The size of the big component
  int spanbig;   // How many normal components it replaces
  int posbig;    // First component replaced
  int setmax;    // Used to select the base component
  int bigsetmin; // setmin for the big one
  int bigsetmax; // setmax for the big one
  bitmap bmp;    // The actual bits
  h3 hash;       // The hash function
  int offsets[MAX_COMPONENTS+1]; // The bit offsets of the components
  int bigoffset; // The bit offset of the big component
};

#endif //ABMP_H
