/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 08/01/2002 */

#include <stdlib.h>
#include <stdio.h>
#include "h3.h"
#include "../readwrite/assume.h"

h3::h3(int sizeofkey){
  int n;
  keysize=sizeofkey;
  assume(RAND_MAX>=0xFFFF,"Too few random bits.\n");
  lookup=(uint32bit*)malloc(keysize*256*sizeof(uint32bit));
  if(lookup==NULL){
    fprintf(stderr,"Failed to allocate %u bytes for the hash function\n",
	    keysize*256*sizeof(uint32bit));
    exit(1);
  }

  for(n=0;n<keysize*256;n++){
    lookup[n]=(rand()<<16)|rand();
  }
}

h3::~h3(){
  free(lookup);
}

uint32bit h3::compute(const byte* data){
  uint32bit result=0;
  int i;
  for(i=0;i<keysize;i++){
    result=result^lookup[256*i+(data)[i]];
  }
  return result;
}
