/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 08/01/2002 */

/* A good hash function similar to the Carter-Wegman H3. */

#ifndef H3_H
#define H3_H

#include "../datatypes/typedefs.h"

typedef unsigned int uint32bit;

class h3{
 public:
  h3(int sizeofkey);
  ~h3();
  uint32bit compute(const byte* data); /* Computes the hash of the data */
 private:
  int keysize;
  uint32bit* lookup;
  /* The lookup table used for computing the hash efficiently. */ 
};

#endif /* H3_H */
