/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/19/2003 */

/* A compound contains up to 20 things. */

#ifndef COMPOUND_H
#define COMPOUND_H

#include "thing.h"

#define MAX_COMPOUND_SIZE 20

class compound:public thing{
 public:
  compound(thing*t0=NULL, thing*t1=NULL, thing*t2=NULL, thing*t3=NULL,
	   thing*t4=NULL, thing*t5=NULL, thing*t6=NULL, thing*t7=NULL,
	   thing*t8=NULL, thing*t9=NULL, thing*t10=NULL, thing*t11=NULL,
	   thing*t12=NULL, thing*t13=NULL, thing*t14=NULL, thing*t15=NULL,
	   thing*t16=NULL, thing*t17=NULL, thing*t18=NULL, thing*t19=NULL);
  unsigned int getbinsize(){return offsets[MAX_COMPOUND_SIZE];}
  unsigned int getmaxhrsize(){return maxhrsize;}
  void print (buffer& b, const  byte* data);
  int parse (buffer& b, byte* data);
  void printname(buffer& b);
  void prettyprint(buffer& b, const byte* data);
  void prettyprintname(buffer& b);
  int getnumthings(){return numthings;}
  thing& getthing(int index){return *things[index];}
  unsigned int getoffset(int index){return offsets[index];}
 protected:
  thing* things[MAX_COMPOUND_SIZE];
  /* The actual things (the arguments to the constructor).*/
  /* We also precompute some other stuff at initialization so that we
     speed up later computations. */
  unsigned int numthings; /* The number of things. */
  unsigned int offsets[MAX_COMPOUND_SIZE+1];
  /* The offset at which each object starts in the binary data
     representation of the compound (offset[MAX_COMPOUND_SIZE] is
     always the size of the binary data associated with the
     compound). */
  unsigned int maxhrsize;
};

#endif /* COMPOUND_H */
