/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/10/2002 */

#include "ip.h"

void ip::print (buffer& b,const byte* data){
  b.offset+=sprintf(b.buff+b.offset,"%u.%u.%u.%u",
		    (unsigned)(*(data+3)),
		    (unsigned)(*(data+2)),
		    (unsigned)(*(data+1)),
		    (unsigned)(*(data+0)));
}

int ip::parse (buffer& b, byte* data){
  if(!b.parse_unsigned1(data+3)){
    b.errorstring="Cannot parse first byte of IP address.";
    return 0;
  }
  if(!b.parse_char('.',"First dot missing from IP address.")){
    return 0;
  }
  if(!b.parse_unsigned1(data+2)){
    b.errorstring="Cannot parse second byte of IP address.";
    return 0;
  }
  if(!b.parse_char('.',"Second dot missing from IP address.")){
    return 0;
  }
  if(!b.parse_unsigned1(data+1)){
    b.errorstring="Cannot parse third byte of IP address.";
    return 0;
  }
  if(!b.parse_char('.',"Third dot missing from IP address.")){
    return 0;
  }
  if(!b.parse_unsigned1(data+0)){
    b.errorstring="Cannot parse last byte of IP address.";
    return 0;
  }
  return 1;
}

