/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/10/2002 */

/* This header describes the port number object. */

#ifndef PORT_H
#define PORT_H

#include "field.h"

/* The internal binary representation of a port number */
#pragma pack(1)
struct portstruct{
  uint2 portnumber;
  uint1 isdefined; /* port numbers not defined for all protocols (ICMP) */
};
#pragma pack()

inline uint1& isdefport(const void* data){
  return ((portstruct*)data)->isdefined;}
inline uint2& portnum(const void* data){
  return ((portstruct*)data)->portnumber;}

class port:public field{
 public:
  port(char* name):field(name){;}
  unsigned int getbinsize(){return sizeof(portstruct);}
  unsigned int getmaxhrsize(){return 5;}
  void print (buffer& b, const byte* data);
  int parse (buffer& b, byte* data);
};

#endif /* PORT_H */
