/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/19/2003 */

#ifndef TYPEDEFS_H
#define TYPEDEFS_H

typedef unsigned char uint1;
typedef unsigned short int uint2;
typedef unsigned int uint4;
typedef unsigned long long int uint8;
typedef signed long long int sint8;

typedef unsigned char byte;

inline int equals(const byte* data1, const byte* data2, int n){
  /* Just checks whether the n bytes starting at data1 are the same as
     those starting at data2. */
  for(int i=0;i<(n>>2);i++){
    if(((unsigned int*)data1)[i]!=((unsigned int*)data2)[i]){
      return 0;
    }
  }
  for(int i=(n>>2)<<2;i<n;i++){
    if(data1[i]!=data2[i]){
      return 0;
    }
  }
  return 1;
}

inline void copy(const byte* src, byte* dest, int n){
  /* Copies n bytes from src to dest */
  for(int i=0;i<(n>>2);i++){
    ((unsigned int*)dest)[i]=((unsigned int*)src)[i];
  }
  for(int i=(n>>2)<<2;i<n;i++){
    dest[i]=src[i];
  }
}


#endif /* TYPEDEFS_H */
