/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/21/2003 */

#include <stdlib.h>
#include <string.h>
#include "hash_map.h"

hash_map::hash_map(unsigned int keysize, unsigned int valuesize):
  ks(keysize),vs(valuesize),es(keysize+valuesize+sizeof(entrylist*)),
  hashfun(keysize){
  ts=0;
  table=NULL;
  for(int i=1;i<166;i++){blocks[i]=(entrylist*)0xbadbad0;}
  numblocks=0;
}

hash_map::~hash_map(){
  free(table);
  for(int i=0;i<numblocks;i++){free(blocks[i]);}
}

int hash_map::has(const byte* key){
  for(entrylist* crt=table[hashfun(key)%ts];crt!=NULL;crt=crt->next){
    if(equals(key,crt->entry,ks)){
      return 1;
    }
  }
  return 0;
}

void hash_map::insert(const byte* key){
  entrylist** crtp;
  for(crtp=table+hashfun(key)%ts;*crtp!=NULL;crtp=&((*crtp)->next)){
    if(equals(key,(*crtp)->entry,ks)){
      return;
    }
  }
  add_key(key,crtp);
}

byte* hash_map::operator[](const byte* key){
  entrylist** crtp;
  for(crtp=table+hashfun(key)%ts;*crtp!=NULL;crtp=&((*crtp)->next)){
    if(equals(key,(*crtp)->entry,ks)){
      return (*crtp)->entry+ks;
    }
  }
  return add_key(key,crtp);
}

hash_map_iterator::hash_map_iterator(hash_map& map):
  ks(map.ks),es(map.es){
  crtentry=NULL;
}
