/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/15/2002 */

/* The asciifilereader reads a file (e.g. trace, list of large flows,
   etc.) in ASCII format (one compound on each line). Based on the
   file name, it detects whether it is compressed with gzip (extension
   .gz) and handles that case correctly. Data is read into the given
   byte array. */

#ifndef ASCIIFILE_H
#define ASCIIFILE_H

#include "buffer.h"
#include "basicfilereader.h"
#include "../datatypes/compound.h"

class asciifilereader{
 public:
  asciifilereader(const char* filename, compound& fields);
  /* The file name and the simple objects that make up the record */
  byte* getnextrecord();
  /* If there is a record to read returns its parsed contents */
  ~asciifilereader();
 private:
  compound* fields; /* This compound establishes the structure of the file. */
  byte* databuffer; /* The parsed data */
  basicfilereader f;
};

#endif /* ASCIIFILE_H */
