/* See bmpcount/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 12/05/2002 */

/* The basic file reader is a simple interface for reading a file line
   by line using a buffer */

#ifndef BASICFILEREADER_H
#define BASICFILEREADER_H

#include <stdio.h>
#include "buffer.h"

class basicfilereader{
 public:
  basicfilereader(const char* filename);
  ~basicfilereader();
  int getnextline(int skipcomments=1);
  /* Reads the next line from the file into the buffer. */
  unsigned getlinenum(){return linenumber;}
  void printbuffererror(char* errorstr=NULL);
  /* This is what we do before dying with a syntax error. */
  void succeedordie(int condition, char* errorstr=NULL)
    {if(!condition){printbuffererror(errorstr);}}
  buffer b;
 private:
  unsigned int linenumber;
  FILE* file;
  const char* fname;
};

#endif /* BASICFILEREADER_H */
