#!/usr/bin/perl -w

# This script finds the magic constants (rho_min, rho_max and the
# corresponding coefficient f(k) from b=f(k)/epsilon^2) for a
# multiresolution bitmap for various values of k. The output of this
# script is what goes into the constants defined in configuremrbmp.pl.

sub error($$){
  my ($rho,$k)=($_[0],$_[1]);
  return (sqrt((($k-1)/$k*(exp($rho)+exp($rho/$k)-2)+exp($rho/$k/$k)-1)*($k-1)/$k)/$rho);
#  return (sqrt((($k-1)/$k*(exp($rho)-1)+exp($rho/$k)-1)*($k-1)/$k)/$rho);
}

foreach $k (2,3,4,5,6,7,8,9,10,11,12,13,14,15,16){
  $rhomin=1.4;
  $rhomax=2;
  while($rhomax/$rhomin<$k){
    if(error($rhomin,$k)>error($rhomax,$k)){
      $rhomax+=0.0001;
    } else {
      $rhomin-=0.0001;
    }
  }
  print "$k\t$rhomin\t$rhomax";
  if(error($rhomin,$k)>error($rhomax,$k)){
    print "\t".(error($rhomin,$k)**2)."\n";
  } else {
    print "\t".(error($rhomax,$k)**2)."\n";
  }
}
